(**************************************************************************)
(*                                                                        *)
(*           Graphikunit, die den Eisatz von Graph.tpu und den            *)
(*           BGI- Treibern berfluessig macht                             *)
(*                                                                        *)
(*           Ralph Uhl, 1998       ralph@r-uhl.de                         *)
(*                                                                        *)
(*           use at own risk!                                             *)
(**************************************************************************)
{$O+,F+}
Unit vga;

interface

procedure Graphics(mode:word);
procedure Textmode;
procedure Plot(x,y:integer;col:byte);
procedure Circle(x,y,rad:integer;col:byte);
procedure Locate(x,y:integer;var col:byte);
procedure GetColor(colorno:byte;var r,g,b:byte);
procedure SetColor(colorno,r,g,b:byte);
procedure Line(a,b,c,d:integer;col:byte);
procedure drawto(x,y:integer;col:byte);
procedure Box(a,b,c,d:integer;col:byte);
procedure text8;
procedure setchar(x,y:integer;ascii,col:byte);
procedure gtext(x,y:integer;txt:string;col:byte);

implementation

USES dos,Crt;


var reg : registers;
    s,t : integer;
    xp,yp:integer;
    xdraw,ydraw:integer;
{}
Procedure Graphics(mode:word);  { Den 320x200x256 mode aktivieren }
BEGIN
     reg.ax:=mode;
     intr($0010,reg);
  END;


{}
Procedure Textmode;  { Wieder in den text mode }
BEGIN
     reg.ax:=$0003;
     intr($0010,reg);
END;


{}

Procedure Plot (X,Y : Integer; Col : Byte);
  { Malt einen Punkt }
BEGIN
  reg.ah:=$000c;
  reg.al:=col;
  reg.cx:=x;
  reg.dx:=y;
  reg.bx:=1;
  intr($0010,reg);
  xdraw:=x;ydraw:=y;
END;


Procedure Splot (a,o : Integer; Co : Byte);
  { Malt einen Punkt }
BEGIN
  reg.ah:=$000c;
  reg.al:=co;
  reg.cx:=a;
  reg.dx:=o;
  reg.bx:=1;
  intr($0010,reg);
END;

procedure circle;
begin
 for t:=0 to rad do begin
  yp:=round(sqrt(rad*rad-t*t));
  splot(x+t,y+yp,col);splot(x-t,y+yp,col);
  splot(x+t,y-yp,col);splot(x-t,y-yp,col);
  splot(x+yp,y+t,col);splot(x-yp,y+t,col);
  splot(x+yp,y-t,col);splot(x-yp,y-t,col);
  end;
 end;

Procedure Locate(X,Y : Integer;var Col : Byte);
Begin
  reg.ah:=$000d;
  reg.dx:=y;
  reg.cx:=x;
  reg.bh:=0;
  intr($0010,reg);
  col:=reg.al;
  End;

Procedure GetColor(ColorNo : Byte; Var R,G,B : Byte);
  { Holt die Rot-, Gruen- und Blauwerte einer besrimmten Farbe }
Begin
   Port[$3c7] := ColorNo;
   R := Port[$3c9];
   G := Port[$3c9];
   B := Port[$3c9];
End;


{}
Procedure SetColor(ColorNo : Byte; R,G,B : Byte);
  { Setzt die entspr. Werte }
Begin
   Port[$3c8] := ColorNo;
   Port[$3c9] := R;
   Port[$3c9] := G;
   Port[$3c9] := B;
End;

Procedure line(a,b,c,d:integer;col:byte);
  { Linie von a,b nach c,d in der Farbe col }
   Function sgn(a:real):integer;
   BEGIN
        if a>0 then sgn:=+1;
        if a<0 then sgn:=-1;
        if a=0 then sgn:=0;
   END;
var u,s,v,d1x,d1y,d2x,d2y,m,n:real;
    i:integer;
BEGIN
     u:= c - a;
     v:= d - b;
     d1x:= SGN(u);
     d1y:= SGN(v);
     d2x:= SGN(u);
     d2y:= 0;
     m:= ABS(u);
     n := ABS(v);
     IF NOT (M>N) then
     BEGIN
          d2x := 0 ;
          d2y := SGN(v);
          m := ABS(v);
          n := ABS(u);
     END;
     s := INT(m / 2);
     FOR i := 0 TO round(m) DO
     BEGIN
          plot(a,b,col);
          s := s + n;
          IF not (s<m) THEN
          BEGIN
               s := s - m;
               a:= a +round(d1x);
               b := b + round(d1y);
          END
          ELSE
          BEGIN
               a := a + round(d2x);
               b := b + round(d2y);
          END;
     END;
xdraw:=c;ydraw:=d;
END;

procedure drawto;
begin
 line(xdraw,ydraw,x,y,col);
end;


procedure box;
begin
 for s:=a to c do begin
  for t:=b to d do begin
   plot(s,t,col);
  end;
 end;
end;

procedure text8; {schaltet die 8x8 Zeichen darstellung ein statt 8x16 }
begin
 reg.ah:=$0011;
 reg.al:=$0023;
 reg.bl:=0;
 reg.dl:=$0003;
 intr($0010,reg);
end;

procedure setchar(x,y : integer; ascii,col:byte);
    {setzt ein Ascii Zeichen an der pos. x,y mit Farbe col}
  begin
    reg.ah:=$0002;
    reg.bh:=0;
    reg.dh:=y;
    reg.dl:=x;
    intr($0010,reg);
    reg.ah:=$0009;
    reg.al:=ascii;
    reg.bh:=0;
    reg.bl:=col;
    reg.cx:=1;
    intr($0010,reg);
  end;

procedure gtext(x,y:integer;txt:string;col:byte);
             {gibt text an der stelle x,y aus mit Farbe col
             Achtung x:0-79 y:0-24 also nicht die Graphikposition!!}
 var lauf:integer;
       ch:char;
  begin
   for lauf:=1 to length(txt) do begin;
         ch:=txt[lauf];
         setchar(x+lauf,y,ord(ch),col);
   end;
  end;


end.